<?php
namespace Teknisa\EST\Modules\EstoqueCego\Factories;

use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Est96000DivergenciasInventarioCegoFactory {
    protected $connection;
    protected $entityManager;

    public function __construct ($entityManager) {
        $this->connection = $entityManager->getConnection();
		$this->entityManager = $entityManager;
    }
    
    public function getParperdivestceg($params) {
        $sql = "SELECT VRPERDIVESTCEG
                  FROM PARPERDIVESTCEG
                 WHERE CDFILIAL = :CDFILIAL
                   AND :CDPRODUTO BETWEEN CDPRODUTO AND CDPRODUTO||'zzzzzzzzzz'
                 ORDER BY CDPRODUTO DESC";

        $query = $this->connection->prepare($sql);
        $query->execute($params);
        $result = $query->fetch();
        return empty($result) ? 0 : $result['VRPERDIVESTCEG'];
    }
    
    public function getCardapioInfo($params) {
        $sql = "SELECT C.NRCARDAPIO, R.CDFILANCESTQ, R.NRLANCESTQ
                  FROM CARDADIA C, RETIRADA R
                 WHERE C.CDFILIAL    = :CDFILIAL
                   AND C.CDSERVFILI  = :CDSERVFILI
                   AND C.DTCARDAPIO  = :DTCARDAPIO
                   AND (C.NRCARDAPIO = :NRCARDAPIO OR :NRCARDAPIO = 'T')
                   AND R.CDFILIAL = C.CDFILIAL
                   AND R.NRCARDAPIO = C.NRCARDAPIO";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetch();
    }
    
    public function VerifyRetirada($params) {
        $sql =  "SELECT L.NRLANCESTQ
                   FROM LANCTOESTOQ L, RETIRADA R
                  WHERE L.CDFILIMOVI = :CDFILIMOVI
                    AND L.DTLANCESTQ = :DTLANCESTQ
                    AND L.IDTPLANCTO = '3'
                    AND L.CDFILIAL = R.CDFILANCESTQ
                    AND L.NRLANCESTQ = R.NRLANCESTQ
                  UNION ALL
                 SELECT L.NRLANCESTQ
                   FROM LANCTOESTOQ L, RETIRADAESTO R
                  WHERE L.CDFILIMOVI = :CDFILIMOVI
                    AND L.DTLANCESTQ = :DTLANCESTQ
                    AND L.IDTPLANCTO = '3'
                    AND L.CDFILIAL = R.CDFILIALLAN
                    AND L.NRLANCESTQ = R.NRLANCESTQ";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }
    
    public function VerifyRequisition($params) {
        $sql =  "SELECT NRREQUESTO
                   FROM REQUESTO R
                  WHERE (R.CDFILIAL = :CDFILIAL )
                    AND (R.DTREQUESTO  = :DTCONTAGEM )
                    AND (:IDREQUISAO = 'E')
                  UNION ALL
                 SELECT NRREQUEXTR
                   FROM PREVRETI PR
                  WHERE (PR.CDFILIAL = :CDFILIAL)
                    AND (PR.DTPREVRETI = :DTCONTAGEM)
                    AND (:IDREQUISAO = 'P')";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }
    
    public function VerifyEfetive($params) {
        $sql =  "SELECT CDSERVFILI
                   FROM EFETCLIE
                  WHERE CDFILIAL = :CDFILIAL
                    AND DTEFETCLIE = :DTCONTAGEM
                    AND :IDEFETIVO = 'P'
                  UNION ALL
                 SELECT CDSERVFILI
                   FROM EFECLIFAT
                  WHERE CDFILIAL = :CDFILIAL
                    AND DTFATURAM = :DTCONTAGEM
                    AND :IDEFETIVO = 'F'
                  UNION ALL
                 SELECT CDSERVFILI
                   FROM EFECLIFATTUR
                  WHERE CDFILIAL = :CDFILIAL
                    AND DTFATURAMTUR = :DTCONTAGEM
                    AND :IDEFETIVO = 'F'";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }
    
    public function getItemsWithoutCost($params) {
        $sql =  "SELECT IT.CDFILIAL, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.DTCONTAGEM,
                        P.CDPRODUTO, P.NMPRODUTO, NRLOTEESTQ, NRSUBLOTE
                  FROM ITEMINVENTCEGO IT, INVENTESTCEGO I, PRODUTO P
                 WHERE IT.CDFILIAL     = :CDFILIAL
                   AND IT.CDALMOXARIFE = :CDALMOXARIFE
                   AND IT.CDLOCALESTOQ = :CDLOCALESTOQ
                   AND IT.DTCONTAGEM   = :DTCONTAGEM
                   AND IDAJUSTEGERAIT  = 'N'
                   AND IT.CDFILIAL     = I.CDFILIAL
                   AND IT.CDALMOXARIFE = I.CDALMOXARIFE
                   AND IT.CDLOCALESTOQ = I.CDLOCALESTOQ
                   AND IT.DTCONTAGEM   = I.DTCONTAGEM
                   AND IT.CDPRODUTO    = P.CDPRODUTO";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }
}