/******************************************************************************/
/************************ GERA SUGESTO DE COMPRAS ****************************/
CREATE OR REPLACE PROCEDURE GERA_SUGESTAO_COMPRA ( P_CDFILIAL     IN VARCHAR2,
                                                   P_CDFORNECED   IN VARCHAR2,
                                                   P_PRODINI      IN VARCHAR2,
                                                   P_PRODFIN      IN VARCHAR2,
                                                   P_DTREFE       IN DATE,
                                                   P_NRDIACOMPRA  IN VARCHAR2,
                                                   P_NRDIAEXCESS  IN VARCHAR2,
                                                   P_DTQTDE1      IN DATE,
                                                   P_DTQTDE2      IN DATE,
                                                   P_DTQTDE3      IN DATE,
                                                   P_DTPOSICAO    IN DATE,
                                                   P_NRSUGCOMPRA  IN VARCHAR2,
                                                   P_IDTPRELSUG   IN VARCHAR2,
                                                   P_IDGERASOLCMP IN VARCHAR2,
                                                   P_CDCLIENTE    IN VARCHAR2,
                                                   P_DEEXP        IN DATE,
                                                   P_ATEEXP       IN DATE,
                                                   P_TDATA        IN VARCHAR2,
                                                   P_CDFILLAN     IN SOLICITA.CDFILLANCA%TYPE,
                                                   P_NRSOLICMP    IN SOLICITA.NRSOLICMP%TYPE,
                                                   P_DTENTSOLICMP IN DATE,
                                                   P_IDMENSSOLI  OUT VARCHAR2)
AS
   V_NRLISTA      NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_QTSOLIPROD   ITEMSOLI.QTSOLIPROD%TYPE;
   V_NRITESUGCOMP NUMBER;
   V_CTITEMSOLI   NUMBER;
   V_NRNOTAFISC   VARCHAR2(20);
   V_CDFORNECED   VARCHAR(21);
   V_DTENTRSAID   DATE;
   V_QTITEMPROD   FLOAT;
   V_VRUNITITEM   FLOAT;
   V_VRFRETE      FLOAT;
   V_VRIPI        FLOAT;
   V_QTPRZ        FLOAT;
   V_QTDE1        FLOAT;
   V_QTDE2        FLOAT;
   V_QTDE3        FLOAT;
   V_QTDEATUAL    FLOAT;
   V_QTPEDIDA     FLOAT;
   V_QTESTOQUE    FLOAT;
   V_QTMEDIAMES   FLOAT;
   V_QTCOMPRA     FLOAT;
   V_QTEXCESSO    FLOAT;
   V_GERA_QTDE1   FLOAT;
   V_GERA_QTDE2   FLOAT;
   V_GERA_QTDE3   FLOAT;
   V_GERA_QTDEATU FLOAT;
   V_GERA_QTPED   FLOAT;
   V_GERA_QTEST   FLOAT;
   V_CONT         INTEGER;
   V_EXIST        INTEGER;
   V_IDMENSSOLI   VARCHAR2(1);
BEGIN
   V_NRITESUGCOMP := 1;
   V_NRNOTAFISC   := '';
   V_CDFORNECED   := '';
   V_QTITEMPROD   := 0;
   V_VRUNITITEM   := 0;
   V_VRFRETE      := 0;
   V_VRIPI        := 0;
   V_QTPRZ        := 0;
   V_QTDE1 := 0;
   V_QTDE2 := 0;
   V_QTDE3 := 0;
   V_QTDEATUAL  := 0;
   V_QTPEDIDA   := 0;
   V_QTESTOQUE  := 0;
   V_QTMEDIAMES := 0;
   V_QTCOMPRA   := 0;
   V_QTEXCESSO  := 0;
   V_GERA_QTDE1 := 0;
   V_GERA_QTDE2 := 0;
   V_GERA_QTDE3 := 0;
   V_GERA_QTDEATU := 0;
   V_GERA_QTPED   := 0;
   V_GERA_QTEST   := 0;
   V_CONT         := 0;
   V_EXIST        := 0;
   P_IDMENSSOLI   := 0;

   IF P_IDTPRELSUG = '1' THEN
      NOVO_CODIGO('LISTA', V_NRLISTA, 1);
      V_NRLISTA := SUBSTR(V_NRLISTA, 11, 10);
      FOR C_FORN IN (SELECT CDFORNECED
                     FROM FORNECEDOR
                     WHERE (INSTR(NVL(P_CDFORNECED, '_'||CDFORNECED||'_'), '_'||CDFORNECED||'_') > 0)
                     ) LOOP
         INSERT INTO LISTA
           (NRLISTA, CDLISTA)
         VALUES
           (V_NRLISTA, C_FORN.CDFORNECED);
      END LOOP;

      FOR C_REG IN (SELECT PR.CDPRODUTO, PR.CDARVPROD, PR.SGUNIDADE, PR.NMPRODUTO, PR.VRFATOCONV
                    FROM PRODUTO PR
                    WHERE (PR.CDPRODESTO IS NOT NULL)
                      AND (CDARVPROD BETWEEN P_PRODINI AND P_PRODFIN)
                      AND EXISTS
                            (SELECT PF.CDPRODUTO
                             FROM PRODUTO P, PRODFORN PF, LISTA LI
                             WHERE (LI.NRLISTA    = V_NRLISTA)
                               AND (PF.CDFORNECED = LI.CDLISTA)
                               AND (PF.CDPRODUTO  = P.CDPRODUTO)
                               AND (PR.CDARVPROD LIKE P.CDARVPROD||'%'))
                    ) LOOP

         SELECT MAX(QT1.QTDE1), MAX(QT2.QTDE2), MAX(QT3.QTDE3), MAX(QTATU.QTDEATUAL), MAX(POSEST.QTESTOQUE), MAX(PEDIDA.QTPEDIDA)
            INTO V_GERA_QTDE1 , V_GERA_QTDE2,   V_GERA_QTDE3  , V_GERA_QTDEATU, V_GERA_QTEST, V_GERA_QTPED
            FROM
            (SELECT NVL(SUM(QTITEMPROD),0) AS QTDE1
             FROM ITEMPRODUTO IP, NOTAFISCAL NF, DATA DT
             WHERE (NF.CDFILIEMIT   = P_CDFILIAL)
               AND (NF.IDENTRSAIDOP = 'S')
               AND (DT.DTMES        = P_DTQTDE1)
               AND (NF.DTENTRSAID   = DT.DTDATA)
               AND (IP.CDPRODUTO    = C_REG.CDPRODUTO )
               AND (NF.CDFILIAL     = IP.CDFILIAL)
               AND (NF.NRLANCTONF   = IP.NRLANCTONF)) QT1,
            (SELECT NVL(SUM(QTITEMPROD),0) AS QTDE2
             FROM ITEMPRODUTO IP, NOTAFISCAL NF, DATA DT
             WHERE (NF.CDFILIEMIT   = P_CDFILIAL)
               AND (NF.IDENTRSAIDOP = 'S')
               AND (DT.DTMES        = P_DTQTDE2)
               AND (NF.DTENTRSAID   = DT.DTDATA)
               AND (IP.CDPRODUTO    = C_REG.CDPRODUTO)
               AND (NF.CDFILIAL     = IP.CDFILIAL)
               AND (NF.NRLANCTONF   = IP.NRLANCTONF)) QT2,
            (SELECT NVL(SUM(QTITEMPROD),0) AS QTDE3
             FROM ITEMPRODUTO IP, NOTAFISCAL NF, DATA DT
             WHERE (NF.CDFILIEMIT   = P_CDFILIAL)
               AND (NF.IDENTRSAIDOP = 'S')
               AND (DT.DTMES        = P_DTQTDE3)
               AND (NF.DTENTRSAID   = DT.DTDATA)
               AND (IP.CDPRODUTO    = C_REG.CDPRODUTO)
               AND (NF.CDFILIAL     = IP.CDFILIAL)
               AND (NF.NRLANCTONF   = IP.NRLANCTONF)) QT3,
            (SELECT NVL(SUM(QTITEMPROD),0) AS QTDEATUAL
             FROM ITEMPRODUTO IP, NOTAFISCAL NF, DATA DT
             WHERE (NF.CDFILIEMIT   = P_CDFILIAL)
               AND (NF.IDENTRSAIDOP = 'S')
               AND (DT.DTMES        = TO_DATE('01/'|| TO_CHAR(P_DTREFE, 'MM/YYYY')))
               AND (NF.DTENTRSAID   = DT.DTDATA)
               AND (NF.DTENTRSAID  <= P_DTREFE)
               AND (NF.CDFILIAL     = IP.CDFILIAL)
               AND (NF.NRLANCTONF   = IP.NRLANCTONF)
               AND (IP.CDPRODUTO    = C_REG.CDPRODUTO)) QTATU,
            (SELECT PE.QTESTDIACON AS QTESTOQUE
             FROM POSESTCONS PE
             WHERE (PE.CDFILIAL  =  P_CDFILIAL)  AND
                   (PE.CDPRODUTO =  C_REG.CDPRODUTO) AND
                   (PE.DTPOSESTCON = DTMAXPOSEST(P_CDFILIAL, C_REG.CDPRODUTO, P_DTPOSICAO + 1))) POSEST,
            (SELECT NVL(SUM(QTPROGENTAF),0) AS QTPEDIDA
             FROM AUTOFORNE AF, ITEMAUTF IA
             WHERE (AF.CDFILDEST  = P_CDFILIAL)                                             AND
                   (AF.IDBAIXAAF IS NULL)                                                   AND
                   (INSTR(NVL(P_CDFORNECED, '_'||AF.CDFORNECED||'_'), '_'||AF.CDFORNECED||'_') > 0) AND
                   (AF.CDFILDEST  = IA.CDFILDEST)                                           AND
                   (AF.CDFILLANC  = IA.CDFILLANC)                                           AND
                   (AF.NRAUTOFORN = IA.NRAUTOFORN)                                          AND
                   (IA.DTPROGENTAF < P_DTPOSICAO + 1)                                       AND
                   (IA.CDPRODUTO  = C_REG.CDPRODUTO)                                        AND
                   (AF.IDSITUATUAAF IS NULL)                                                AND
                   (AF.IDAFFORALIM = 'N')) PEDIDA ;
         IF ( V_GERA_QTDE1 <> 0)OR(V_GERA_QTDE2 <>0)OR(V_GERA_QTDE3 <> 0)OR
            (V_GERA_QTDEATU <> 0)OR(V_GERA_QTEST <> 0)OR(V_GERA_QTPED <>0) THEN
            V_QTDE1 := V_GERA_QTDE1;
            V_QTDE2 := V_GERA_QTDE2;
            V_QTDE3 := V_GERA_QTDE3;
            V_QTDEATUAL  := V_GERA_QTDEATU;
            V_QTESTOQUE  := NVL(V_GERA_QTEST, 0) * NVL(C_REG.VRFATOCONV, 1);
            V_QTMEDIAMES := (( V_GERA_QTDE1 + V_GERA_QTDE2 + V_GERA_QTDE3)/3);
            V_QTPEDIDA   := V_GERA_QTPED;
            V_QTCOMPRA   := ((((( V_GERA_QTDE1 + V_GERA_QTDE2 + V_GERA_QTDE3)/3)/30) * TO_NUMBER(P_NRDIACOMPRA)) - V_QTESTOQUE - V_QTPEDIDA);
            V_QTEXCESSO  := ( V_QTESTOQUE + V_QTPEDIDA - (((( V_GERA_QTDE1 + V_GERA_QTDE2 + V_GERA_QTDE3) / 3)/30)* TO_NUMBER(P_NRDIAEXCESS)));
         END IF;

         V_CONT := 0;
         FOR C_ULTCOMP IN (SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.NRNOTAFISC, NF.DTENTRSAID,NF.CDFORNECED,
                                  FN.NRINSJURFORN, FN.NMRAZSOCFORN, FN.IDTPIJURFORN, IT.VRALIQITEM AS VRIPI,
                                  IE.VRITEMENCA AS VRFRETE, CP.QTPRZ,
                                  SUM(IP.QTITEMPROD) AS QTITEMPROD,
                                 (SUM(IP.VRTOTAITEM)/ SUM(IP.QTITEMPROD)) AS VRUNITITEM
                           FROM
                              NOTAFISCAL NF, ITEMPRODUTO IP, FORNECEDOR FN, ITEMPROIMPOS IT, ITEMENCARGO IE,
                                (SELECT CDFILIAL, NRLANCTONF, MIN(QTDIASVENPAG) AS QTPRZ
                                 FROM CONTAPAGAR
                                 GROUP BY CDFILIAL, NRLANCTONF) CP
                           WHERE
                                 (NF.CDFILIRECE   = P_CDFILIAL)       AND
                                 (NF.IDENTRSAIDOP = 'E')               AND
                                 (NF.CDTIPOOPER   = '01')              AND
                                 (NF.CDFILIAL     = IP.CDFILIAL)       AND
                                 (NF.NRLANCTONF   = IP.NRLANCTONF)     AND
                                 (IP.CDPRODUTO    = C_REG.CDPRODUTO)   AND
                                 (NF.CDFORNECED   = FN.CDFORNECED)     AND
                                 (IP.CDFILIAL     = IT.CDFILIAL   (+)) AND
                                 (IP.NRLANCTONF   = IT.NRLANCTONF (+)) AND
                                 (INSTR(NVL(P_CDFORNECED, '_'||NF.CDFORNECED||'_'), '_'||NF.CDFORNECED||'_') > 0) AND
                                 (IP.NRSEQITPROD  = IT.NRSEQITPROD(+)) AND
                                 (IT.CDIMPOSTO    (+) = '10')          AND
                                 (IT.NRITPROIMPOS (+) = '1')           AND
                                 (NF.CDFILIAL     = IE.CDFILIAL(+))    AND
                                 (NF.NRLANCTONF   = IE.NRLANCTONF(+))  AND
                                 (IE.CDENCARGO    (+) = '01')          AND
                                 (NF.CDFILIAL     = CP.CDFILIAL(+))    AND
                                 (NF.NRLANCTONF   = CP.NRLANCTONF(+))
                           GROUP BY NF.CDFILIAL, NF.NRLANCTONF, NF.NRNOTAFISC, NF.DTENTRSAID, NF.CDFORNECED,
                                    FN.NRINSJURFORN, FN.NMRAZSOCFORN, FN.IDTPIJURFORN, IT.VRALIQITEM, IE.VRITEMENCA,
                                    CP.QTPRZ
                           ORDER BY NF.DTENTRSAID DESC , NF.NRLANCTONF DESC )LOOP
            IF NOT ( (C_ULTCOMP.CDFILIAL IS NULL) OR (C_ULTCOMP.NRLANCTONF IS NULL)
               OR (C_ULTCOMP.NRNOTAFISC IS NULL)) THEN

               V_CDFORNECED    :=  C_ULTCOMP.CDFORNECED;
               V_DTENTRSAID    :=  C_ULTCOMP.DTENTRSAID;
               V_NRNOTAFISC    :=  C_ULTCOMP.NRNOTAFISC;
               V_QTITEMPROD    :=  C_ULTCOMP.QTITEMPROD;
               V_VRUNITITEM    :=  C_ULTCOMP.VRUNITITEM;
               V_VRFRETE       :=  C_ULTCOMP.VRFRETE;
               V_VRIPI         :=  C_ULTCOMP.VRIPI;
               V_QTPRZ         :=  C_ULTCOMP.QTPRZ;

               IF V_CONT = 0 THEN
                  INSERT INTO TRAB_SUGCOMPRA
                     (CDFILSUGCOMP, NRSUGCOMPRA,  CDFORSUGCOMP, CDPROSUGCOMP, DTREFSUGCOMP, NRDIACOMPRA,
                      NRDIAEXCESS,  DTMESANT01,   DTMESANT02,   DTMESANT03,   DTULTCOMPRA,  NRULTNOTAFIS,
                      QTULTITEMPRO, VRULTUNITITE, VRULTFRETE,   VRIPIULTCOMP, QTPRZULTCOMP, QTSAIDAANT01, QTSAIDAANT02, QTSAIDAANT03,
                      QTSAIDAATUAL, QTMEDIAMES,   QTESTOQSGCMP, QTSOLICFORNE, QTCOMPRA,     QTEXCESSO, NRITESUGCOMP)
                  VALUES
                     (P_CDFILIAL ,   P_NRSUGCOMPRA, V_CDFORNECED, C_REG.CDPRODUTO, P_DTREFE,     P_NRDIACOMPRA,
                      P_NRDIAEXCESS, P_DTQTDE1,     P_DTQTDE2,    P_DTQTDE3,       V_DTENTRSAID, V_NRNOTAFISC,
                      V_QTITEMPROD,  V_VRUNITITEM,  V_VRFRETE,    V_VRIPI,         V_QTPRZ,      V_QTDE1, V_QTDE2, V_QTDE3,
                      V_QTDEATUAL,   V_QTMEDIAMES,  V_QTESTOQUE,  V_QTPEDIDA,      V_QTCOMPRA,   V_QTEXCESSO, LPAD(TO_CHAR(V_NRITESUGCOMP), 10, '0'));
               ELSE
                  INSERT INTO TRAB_SUGCOMPRA
                     (CDFILSUGCOMP, NRSUGCOMPRA,  CDFORSUGCOMP, CDPROSUGCOMP, DTREFSUGCOMP, NRDIACOMPRA,
                      NRDIAEXCESS,  DTMESANT01,   DTMESANT02,   DTMESANT03,   DTULTCOMPRA,  NRULTNOTAFIS,
                      QTULTITEMPRO, VRULTUNITITE, VRULTFRETE,   VRIPIULTCOMP, QTPRZULTCOMP, NRITESUGCOMP)
                  VALUES
                     (P_CDFILIAL ,   P_NRSUGCOMPRA, V_CDFORNECED, C_REG.CDPRODUTO, P_DTREFE,     P_NRDIACOMPRA,
                      P_NRDIAEXCESS, P_DTQTDE1,     P_DTQTDE2,    P_DTQTDE3,       V_DTENTRSAID, V_NRNOTAFISC,
                      V_QTITEMPROD,  V_VRUNITITEM,  V_VRFRETE,    V_VRIPI,         V_QTPRZ,      LPAD(TO_CHAR(V_NRITESUGCOMP), 10, '0'));
               END IF;
               V_NRITESUGCOMP := V_NRITESUGCOMP + 1;

               V_CONT := V_CONT + 1;
               IF V_CONT = 3 THEN
                  EXIT;
               END IF;
            END IF;
               V_CDFORNECED    :=  '';
               V_DTENTRSAID    :=  '';
               V_NRNOTAFISC    :=  '';
               V_QTITEMPROD    :=  '';
               V_VRUNITITEM    :=  '';
               V_VRFRETE       :=  '';
               V_VRIPI         :=  '';
               V_QTPRZ         :=  '';
         END LOOP;

         SELECT COUNT(*) INTO V_EXIST
         FROM TRAB_SUGCOMPRA
         WHERE CDFILSUGCOMP = P_CDFILIAL
           AND NRSUGCOMPRA  = P_NRSUGCOMPRA
           AND CDPROSUGCOMP = C_REG.CDPRODUTO;

         IF V_EXIST = 0 THEN
            INSERT INTO TRAB_SUGCOMPRA
               (CDFILSUGCOMP, NRSUGCOMPRA,  CDFORSUGCOMP, CDPROSUGCOMP, DTREFSUGCOMP, NRDIACOMPRA,
                NRDIAEXCESS,  DTMESANT01,   DTMESANT02,   DTMESANT03,   DTULTCOMPRA,  NRULTNOTAFIS,
                QTULTITEMPRO, VRULTUNITITE, VRULTFRETE,   VRIPIULTCOMP, QTPRZULTCOMP, QTSAIDAANT01, QTSAIDAANT02, QTSAIDAANT03,
                QTSAIDAATUAL, QTMEDIAMES,   QTESTOQSGCMP,    QTSOLICFORNE, QTCOMPRA,     QTEXCESSO, NRITESUGCOMP)
            VALUES
               (P_CDFILIAL ,   P_NRSUGCOMPRA, V_CDFORNECED, C_REG.CDPRODUTO, P_DTREFE,     P_NRDIACOMPRA,
                P_NRDIAEXCESS, P_DTQTDE1,     P_DTQTDE2,    P_DTQTDE3,       V_DTENTRSAID, V_NRNOTAFISC,
                V_QTITEMPROD,  V_VRUNITITEM,  V_VRFRETE,    V_VRIPI,         V_QTPRZ,      V_QTDE1, V_QTDE2, V_QTDE3,
                V_QTDEATUAL,   V_QTMEDIAMES,  V_QTESTOQUE,  V_QTPEDIDA,      V_QTCOMPRA,   V_QTEXCESSO, LPAD(TO_CHAR(V_NRITESUGCOMP), 10, '0'));
            V_NRITESUGCOMP := V_NRITESUGCOMP + 1;
         END IF;
      END LOOP;
   END IF;

   IF P_IDTPRELSUG = '2' THEN
      FOR C_PED IN
        (SELECT DISTINCT
            FN.CDFORNECED,   PR.CDPRODUTO, PE.NRPEDIDO, IT.NRITEMPED,
            CL.NRINSJURCLIE, CL.NMRAZSOCCLIE, FI.CDFILIAL , FI.NMFILIAL,
            FN.NRINSJURFORN, FN.NMRAZSOCFORN, IT.QTITEMPED, PR.NMPRODUTO,
            FN.IDTPIJURFORN, CL.IDTPIJURCLIE, IT.QTEXPITEMPED, PE.CDCLIENTE,
            PR.VRFATOCONV
         FROM
            NOTAFISCAL NF, ITEMPRODUTO IP, PRODFORNCOMP PF, FORNECEDOR FN,
            ITEMPEDIDO IT, PEDIDO      PE, CLIENTE  CL, FILIAL     FI,
            PRODUTO    PR
         WHERE
            (IT.CDFILIAL     = P_CDFILIAL   ) AND
            (IP.CDFILIAL     = NF.CDFILIAL   ) AND
            (IP.NRLANCTONF   = NF.NRLANCTONF ) AND
            (IP.NRPEDIDO     = IT.NRPEDIDO   ) AND
            (IP.NRITEMPED    = IT.NRITEMPED  ) AND
            (IT.CDFILIAL     = IP.CDFILIALPED) AND
            (IT.CDPRODUTO    = PF.CDPRODCOMPL) AND
            (IT.IDSITITEMPED in ('1','2','3','7'))  AND
            (PE.CDFILIAL     = IT.CDFILIAL   ) AND
            (PE.NRPEDIDO     = IT.NRPEDIDO   ) AND
            (PE.IDSITPEDIDO  in ('1','2','6')) AND
            (CL.CDCLIENTE    = PE.CDCLIENTE  ) AND
            (FI.CDFILIAL     = PE.CDFILIAL   ) AND
            (FN.CDFORNECED   = PF.CDFORNECED ) AND
            (PR.CDPRODUTO    = PF.CDPRODCOMPL) AND
            (INSTR(NVL(P_CDFORNECED, '_'||FN.CDFORNECED||'_'), '_'||FN.CDFORNECED||'_') > 0) AND
            (INSTR(NVL(P_CDCLIENTE, '_'||CL.CDCLIENTE||'_'), '_'||CL.CDCLIENTE||'_') > 0) AND
            ((NF.DTENTRSAID BETWEEN P_DEEXP AND P_ATEEXP) OR (P_TDATA = 'T')) AND
            (PR.CDARVPROD BETWEEN P_PRODINI AND P_PRODFIN) AND
            (PR.CDPRODESTO IS NOT NULL)
         ORDER BY
            FN.CDFORNECED, PR.CDPRODUTO, FI.CDFILIAL, PE.NRPEDIDO, IT.NRITEMPED
        ) LOOP

         SELECT MAX(PE.QTESTDIACON)
         INTO V_QTESTOQUE
         FROM POSESTCONS PE
         WHERE (PE.CDFILIAL    = P_CDFILIAL)
           AND (PE.CDPRODUTO   = C_PED.CDPRODUTO)
           AND (PE.DTPOSESTCON = DTMAXPOSEST(P_CDFILIAL, C_PED.CDPRODUTO, P_DTPOSICAO + 1));

         INSERT INTO TRAB_SUGCOMPRA
            (CDFILSUGCOMP, NRSUGCOMPRA,  CDFORSUGCOMP,
             CDPROSUGCOMP, NRPEDSUGCOMP, NRITPSUGCOMP,
             CDCLISUGCOMP, QTCOMPRA,     QTESTOQSGCMP,
             NRITESUGCOMP)
         VALUES
            (P_CDFILIAL,      P_NRSUGCOMPRA, C_PED.CDFORNECED,
             C_PED.CDPRODUTO, C_PED.NRPEDIDO, C_PED.NRITEMPED,
             C_PED.CDCLIENTE, NVL(C_PED.QTITEMPED, 0) - NVL(C_PED.QTEXPITEMPED, 0), NVL(V_QTESTOQUE, 0) * NVL(C_PED.VRFATOCONV, 1),
             LPAD(TO_CHAR(V_NRITESUGCOMP), 10, '0'));

         V_NRITESUGCOMP := V_NRITESUGCOMP + 1;
      END LOOP;
   END IF;

   IF P_IDGERASOLCMP = 'S' THEN
      GERA_SOLICMP(P_CDFILIAL,     P_CDFILLAN,   P_NRSOLICMP,
                   P_DTENTSOLICMP, P_DTPOSICAO,  V_NRLISTA,
                   P_NRSUGCOMPRA,  P_IDTPRELSUG, V_IDMENSSOLI);

      P_IDMENSSOLI := V_IDMENSSOLI;
   END IF;

   DELETE FROM LISTA
   WHERE NRLISTA = V_NRLISTA;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_SUGESTAO_COMPRA','4.05.125'); END;
/

